"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fromFile = undefined;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var fromFile = exports.fromFile = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(root) {
    var configFile, config;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            configFile = _path2.default.join(root, "catalyst.json");
            _context.next = 3;
            return fs.readFileAsync(configFile, { encoding: "utf8" });

          case 3:
            config = _context.sent;
            return _context.abrupt("return", init(JSON.parse(config)));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function fromFile(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = init;

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _spec = require("./spec");

var _spec2 = _interopRequireDefault(_spec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));

var noop = function noop(val) {
  return val;
};

function init(obj) {
  return (0, _keys2.default)(_spec2.default).reduce(function (final, key) {
    var val = obj[key] || _spec2.default[key].defaultValue;
    if (val) {
      final[key] = (_spec2.default[key].transform || noop)(val);
    }
    return final;
  }, {});
}