"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

exports.mergeWithProps = mergeWithProps;
exports.mergeWithObj = mergeWithObj;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function propsFromObject(obj, base) {
  return (0, _keys2.default)(obj).reduce(function (props, key) {
    props[key] = (0, _assign2.default)({}, { value: obj[key] }, base);
    return props;
  }, {});
}

function mergeWithProps(currProps, newProps) {
  var overwrite = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];

  if (overwrite === false) {
    return (0, _assign2.default)({}, newProps, currProps);
  }
  return (0, _assign2.default)({}, currProps, newProps);
}

function mergeWithObj(currProps, newObj) {
  var overwrite = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];

  return mergeWithProps(currProps, propsFromObject(newObj, { enumerable: true }), overwrite);
}