"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.once = undefined;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var once = exports.once = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(config) {
    var root, files;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _fsdb2.default)(config);

          case 3:
            root = _context.sent;
            _context.next = 6;
            return (0, _load2.default)(config.layouts);

          case 6:
            files = (0, _render.renderTree)(root, root, _registry.Registry, config.dist);
            _context.next = 9;
            return (0, _write2.default)(config.dist, files);

          case 9:
            _context.next = 14;
            break;

          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);

            console.error(_context.t0);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 11]]);
  }));

  return function once(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _fsdb = require("./fsdb");

var _fsdb2 = _interopRequireDefault(_fsdb);

var _load = require("./render/load");

var _load2 = _interopRequireDefault(_load);

var _write = require("./render/write");

var _write2 = _interopRequireDefault(_write);

var _render = require("./render");

var _registry = require("./registry");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = once;