"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (parsers) {
  var _this = this;

  return (0, _mapRecurse2.default)(function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(node) {
      var raw, parsed;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!node.isFile) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return fs.readFileAsync(node.pathStr, { encoding: "utf8" });

            case 3:
              raw = _context.sent;
              parsed = parsers[node.path.ext.replace(".", "")](raw);

              node.data = (0, _mergeProps.mergeWithObj)(node.data, parsed, false);

            case 6:
              return _context.abrupt("return", node);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _mapRecurse = require("../mapRecurse");

var _mapRecurse2 = _interopRequireDefault(_mapRecurse);

var _mergeProps = require("../mergeProps");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));