"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));
var mkdirp = _bluebird2.default.promisify(require("mkdirp"));

function mkdirpAll(paths) {
  return _bluebird2.default.all(paths.map(function (p) {
    return mkdirp((0, _path.parse)(p).dir, undefined);
  }));
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(dist, files) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            files.forEach(function (f) {
              f.path = (0, _path.join)(dist, f.path);
            });
            _context.next = 3;
            return mkdirpAll(files.map(function (f) {
              return f.path;
            }));

          case 3:
            return _context.abrupt("return", _bluebird2.default.all(files.map(function (f) {
              return fs.writeFileAsync(f.path, f.data);
            })));

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function write(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return write;
}();